Bug 1649952 (python-nineml) - Review Request: python-nineml - A tool for reading, writing and generally working with 9ML
Summary: Review Request: python-nineml - A tool for reading, writing and generally wor...
Keywords:
Status: CLOSED ERRATA
Alias: python-nineml
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Miro Hrončok
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: fedora-neuro
TreeView+ depends on / blocked
 
Reported: 2018-11-14 23:03 UTC by Ankur Sinha (FranciscoD)
Modified: 2018-11-25 02:26 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2018-11-25 02:26:03 UTC
mhroncok: fedora-review+


Attachments (Terms of Use)

Description Ankur Sinha (FranciscoD) 2018-11-14 23:03:10 UTC
Spec URL: https://ankursinha.fedorapeople.org/python-nineml/python-nineml.spec
SRPM URL: https://ankursinha.fedorapeople.org/python-nineml/python-nineml-1.0-1.fc29.src.rpm

Description: 
NineML (9ML) is a language for describing the dynamics and connectivity of
neuronal network simulations (http://nineml.net), which is defined by the
NineML specification.

The NineML Python Library is a software package written in Python, which maps
the NineML object model onto Python classes for convenient creation,
manipulation and validation of NineML models, as well as handling their
serialisation to and from XML, JSON, YAML, and HDF5.

Links
- Online documentation: http://nineml-python.readthedocs.org
- Mailing list: NeuralEnsemble Google Group
- Issue tracker: https://github.com/INCF/nineml-python/issues


Fedora Account System Username: ankursinha

F29 scratch build: https://koji.fedoraproject.org/koji/taskinfo?taskID=30889454
Rawhide scratch build: https://koji.fedoraproject.org/koji/taskinfo?taskID=30889421

Comment 1 Miro Hrončok 2018-11-15 19:07:47 UTC
Out of curiosity. Is there any specific reason to add python2 package to Fedora 29 just to not add it in Fedora 30?

Comment 2 Miro Hrončok 2018-11-15 19:09:34 UTC
The test seem fixed upstream. Would it be possible to backport the fix?

Comment 4 Miro Hrončok 2018-11-15 19:13:16 UTC
The docs won't build in mock without python2-sphinx.
Set SPHINXBUILD=sphinx-build-3 explicitly when running make html.
(Untested, so only 90 % sure.)

Comment 5 Miro Hrončok 2018-11-15 19:25:39 UTC
Several language things:

- I think that en_US would use serialization over serialisation (yet I'm not an expert)

- Documentatation is a typo


Please consider my previous notes. Other than that, this package is APPROVED (assuming the typo is fixed).



Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: License file installed when any subpackage combination is installed.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
[?]: Package functions as described.
[?]: Latest version is packaged.
[-]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[?]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python3-nineml-1.0-1.fc30.noarch.rpm
          python-nineml-doc-1.0-1.fc30.noarch.rpm
          python-nineml-1.0-1.fc30.src.rpm
python3-nineml.noarch: W: spelling-error %description -l en_US serialisation -> serialization, sensationalist, sensationalism
python-nineml-doc.noarch: W: spelling-error %description -l en_US Documentatation -> Documentation, Instrumentation, Argumentation
python-nineml.src: W: spelling-error %description -l en_US serialisation -> serialization, sensationalist, sensationalism
3 packages and 0 specfiles checked; 0 errors, 3 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
python-nineml-doc.noarch: W: spelling-error %description -l en_US Documentatation -> Documentation, Instrumentation, Argumentation
python-nineml-doc.noarch: W: invalid-url URL: https://github.com/INCF/nineml-python <urlopen error [Errno -2] Name or service not known>
python3-nineml.noarch: W: spelling-error %description -l en_US serialisation -> serialization, sensationalist, sensationalism
python3-nineml.noarch: W: invalid-url URL: https://github.com/INCF/nineml-python <urlopen error [Errno -2] Name or service not known>
2 packages and 0 specfiles checked; 0 errors, 4 warnings.



Requires
--------
python-nineml-doc (rpmlib, GLIBC filtered):

python3-nineml (rpmlib, GLIBC filtered):
    python(abi)
    python3dist(h5py)
    python3dist(lxml)
    python3dist(pyyaml)
    python3dist(sympy)



Provides
--------
python-nineml-doc:
    python-nineml-doc

python3-nineml:
    python3-nineml
    python3.7dist(nineml)
    python3dist(nineml)



Source checksums
----------------
https://github.com/INCF/nineml-python/archive/1.0/nineml-1.0.tar.gz :
  CHECKSUM(SHA256) this package     : 610eadb3a162ccb8adf3adc03938cf0ad261d696c779a26a51b446f99726645b
  CHECKSUM(SHA256) upstream package : 610eadb3a162ccb8adf3adc03938cf0ad261d696c779a26a51b446f99726645b

Comment 6 Ankur Sinha (FranciscoD) 2018-11-15 20:25:35 UTC
(In reply to Miro Hrončok from comment #1)
> Out of curiosity. Is there any specific reason to add python2 package to
> Fedora 29 just to not add it in Fedora 30?

At the moment, I'm doing it simply because we can provide a python2 version in F29. Researchers are sometimes finicky about what version they use. In the future, we may provide neurofedora packages to EPEL etc too, if researchers require it, then this type of general spec will be easier to tweak (or so I think).

(In reply to Miro Hrončok from comment #2)
> The test seem fixed upstream. Would it be possible to backport the fix?

Done. I've included the required patches and enabled the tests.

(In reply to Miro Hrončok from comment #3)
> I'd recommend using
> https://docs.fedoraproject.org/en-US/packaging-guidelines/Python/
> #_automatically_generated_dependencies

Done. I'll double check that the generated requires are complete. I've seen a few python packages that do not include the complete set of requirements :/

(In reply to Miro Hrončok from comment #4)
> The docs won't build in mock without python2-sphinx.
> Set SPHINXBUILD=sphinx-build-3 explicitly when running make html.
> (Untested, so only 90 % sure.)

I've added this, but currently docs don't build so they're still disabled.

(In reply to Miro Hrončok from comment #5)
> Several language things:
> 
> - I think that en_US would use serialization over serialisation (yet I'm not
> an expert)

Yes, corrected.


> - Documentatation is a typo

Corrected too.

Thanks for the quick review. Updated spec/srpm here: 

https://ankursinha.fedorapeople.org/python-nineml/python-nineml.spec
https://ankursinha.fedorapeople.org/python-nineml/python-nineml-1.0-2.fc29.src.rpm

New rawhide scratch build:
https://koji.fedoraproject.org/koji/taskinfo?taskID=30905438

Requested SCM here
https://pagure.io/releng/fedora-scm-requests/issue/8852

Comment 7 Gwyn Ciesla 2018-11-15 21:01:57 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/python-nineml

Comment 8 Fedora Update System 2018-11-15 22:05:49 UTC
python-nineml-1.0-3.fc29 has been submitted as an update to Fedora 29. https://bodhi.fedoraproject.org/updates/FEDORA-2018-8c92f3c169

Comment 9 Miro Hrončok 2018-11-15 23:06:54 UTC
    SPHINXBUILD=sphinx-build-3 make html

this probably should be:

    make SPHINXBUILD=sphinx-build-3 html

Yet maybe make picks up environment variables (never tried it with sphinx).
Just make sure you test this in mock once you enabale the docs (magically, this works in Koji even without the explicit set of the variable).

Comment 10 Miro Hrončok 2018-11-15 23:07:19 UTC
Executing(%check): /bin/sh -e /var/tmp/rpm-tmp.4nTeL3
+ umask 022
+ cd /builddir/build/BUILD
+ cd nineml-python-1.0
+ nosetests-3.7
..................................................................................................................................................................................................................................
----------------------------------------------------------------------
Ran 226 tests in 337.137s
OK
+ exit 0

Good!

Comment 11 Fedora Update System 2018-11-16 05:52:26 UTC
python-nineml-1.0-3.fc29 has been pushed to the Fedora 29 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2018-8c92f3c169

Comment 12 Fedora Update System 2018-11-25 02:26:03 UTC
python-nineml-1.0-3.fc29 has been pushed to the Fedora 29 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.